
#include "TextValueLoader.h"
#include "ScriptAnalizer.h"
#include <locale.h>
CTextValueLoader::CTextValueLoader()
{
    m_isAnalized = 0;
}
void CTextValueLoader::SetStrStrVector(vector<wstring> vStrStr)//ϐ`܂B
{
    m_vStrStr = vStrStr;
}
void CTextValueLoader::SetIntStrVector(vector<wstring> vIntStr)//intϐ`܂B
{
    m_vIntStr = vIntStr;
}
void CTextValueLoader::SetDoubleStrVector(vector<wstring> vDoubleStr)//{xϐ`܂B
{
    m_vDoubleStr = vDoubleStr;
}

void CTextValueLoader::AnalizeInputFile(wstring fname)//Inputt@C͂܂B
{
    //ScriptAnalizerNB
    setlocale(LC_ALL , "JPN");
	CScriptAnalizer cas;
	INITIALIZE_INFO_DESC iid;
	__int64* pOPK[21];
	for(__int64 r=0;r<15;r++)
	{
		pOPK[r] = new __int64[6];
		for(int s=0;s<6;s++)
		{
			pOPK[r][s]=0;
		}
	}
	wchar_t* pOP[20];
	pOP[0]  = L" ";
	pOP[1]  = L"\"";
	pOP[2]  = L"\r\n";
	pOP[3]  = L"	";
	pOP[4]  = L"-";
	pOP[5]  = L"\uFEFF";
	pOP[6]  = L"//";
	pOP[7]  = L"/*";
	pOP[8]  = L"*/";
	pOP[9] = L",";
	pOP[10]  = L";";
	pOP[11]  = L"e-";
	pOP[12]  = L"E-";
	pOP[13]  = L"E";
	pOP[14]  = L"e";
	pOP[15] = 0;

	pOPK[0][0]  = AS_SPACE_WORD;
	pOPK[1][0]  = AS_STRING_START;
	pOPK[1][1]  = AS_BLOCKWORD_ENTRY + 1;//ubN̑w肷B
	pOPK[1][2]  = AS_STRING_END;
	pOPK[2][0]  = AS_SPACE_WORD;
	pOPK[2][1]  = AS_ESCAPEBLOCK_END;
	pOPK[2][2]  = AS_WORDBREAK;
	pOPK[3][0]  = AS_SPACE_WORD;
	pOPK[4][0]  = AS_RESERVED_WORD;
	pOPK[5][0]  = AS_SPACE_WORD;
	pOPK[6][0]  = AS_ESCAPEBLOCK_START;
	pOPK[6][1]  = AS_BLOCKWORD_ENTRY + 2;
	pOPK[7][0]  = AS_ESCAPEBLOCK_START;
	pOPK[7][1]  = AS_BLOCKWORD_ENTRY + 8;
	pOPK[8][0]  = AS_ESCAPEBLOCK_END;
	pOPK[9][0]  = AS_SPACE_WORD;
	pOPK[10][0] = AS_OPERATION_END;
	pOPK[11][0] = AS_RESERVED_WORD;
	pOPK[12][0] = AS_RESERVED_WORD;
	pOPK[13][0] = AS_RESERVED_WORD;
	pOPK[14][0] = AS_RESERVED_WORD;
	pOPK[15]    = 0;


    int nStrStr , nIntStr , nDoubleStr; 
    int posStrStr , posIntStr , posDoubleStr; 
    int nStrAll;

    vector<wstring> vStrAll;
    vector<bool> vStrBoolAll;
    nStrStr = m_vStrStr.size();
    nIntStr = m_vIntStr.size();
    nDoubleStr = m_vDoubleStr.size();

    nStrAll = nStrStr + nIntStr + nDoubleStr;
    
	const int tvMinus=ASM_USER;
	const int tve    =ASM_USER+1;
	const int tvE    =ASM_USER+2;
    vStrAll.push_back(L"-");
    vStrAll.push_back(L"e");
    vStrAll.push_back(L"E");

    for(int m1=0;m1<nStrStr;m1++)
        vStrAll.push_back(m_vStrStr[m1]);
	
    for(int m1=0;m1<nIntStr;m1++)
        vStrAll.push_back(m_vIntStr[m1]);

    for(int m1=0;m1<nDoubleStr;m1++)
        vStrAll.push_back(m_vDoubleStr[m1]);

    for(int m1=0;m1<nStrAll;m1++)
    {
        vStrBoolAll.push_back(false);
    }
    
    posStrStr    = 1 + ASM_USER;
    posIntStr    = posStrStr + nStrStr;
    posDoubleStr = posIntStr + nIntStr;
	
    //xN^[̃TCYύXĂB
    m_vStr.resize(nStrStr);
    m_vInt.resize(nIntStr);
    m_vDouble.resize(nDoubleStr);


    m_vStrBool.resize(nStrStr);
    m_vIntBool.resize(nIntStr);
    m_vDoubleBool.resize(nDoubleStr);

	wchar_t* pSTB[2];

	pSTB[0] = L"\"";
	pSTB[1] = 0;

	iid.ppOperation = pOP;
	iid.ppOperationKind = pOPK;
	iid.asmEnableNumber = true;
	iid.asmEnableString = true;
	iid.Asd.nStrBlockSet = 1;
	iid.Asd.nTransSet    = 0;
	iid.Asd.pStrBlockStart = pSTB;
	iid.Asd.pStrBlockEnd   = pSTB;
	iid.Asd.pTransStr      = 0;
	iid.Asd.pTransToStr    = 0;
	
	cas.Init(&iid);
	for(__int64 r=0; r < vStrAll.size();r++)
	{
		cas.AdAsmDistinction(vStrAll[r].c_str() , ASM_USER+r);
	}


	//͊JnB
	ANALIZE_DESC ad;
	FILE *hfile;
	__int64 c;
	__int64 hr;
	wchar_t *pcode;
	pcode = 0;

	_wfopen_s(&hfile , fname.c_str() , L"rb");
	if(hfile==0)
	{
        wcout << L"t@C" << fname << L"J܂\n";
		throw -1;
	}

	fseek(hfile , 0 ,  SEEK_END);
	c = ftell(hfile);
	fseek(hfile , 0 , SEEK_SET);

	c/=2;
	pcode = new wchar_t[c+3];
	fread(pcode , sizeof(wchar_t) , c , hfile);

	fclose(hfile);
	pcode[c+1] = 0;//NULLZbgĂB

	
	ad.pCode = pcode;
	ad.nCode = c;
	
	hr = cas.Analize(&ad);
	if(hr!=0)
	{
        wcout << cas.GetLastErr() << L"\n";
		throw -1;
	}
	

	wchar_t* pstr;
	EXE_ASMCODE_DESC ead;
	__int64 nr;
	double bd,vdb[2];
	double Lx,Ly,Lz;
	int    bdi;
	int isminus;
    int cRelOpe;
	cas.AsmSetAssenblyPoint(0);//ǂݍ݃|CgZbgB
	while(true)
	{
		hr = cas.AsmGetNextAssembly(&ead);
		if(hr==1)
		{
			break;
		}
		if(hr!=0)
		{
		    wprintf(cas.GetLastErr());
			throw -1;
		}
        //lǂݎĂ邩ȂB
        cRelOpe = ead.kreg[0] - posStrStr;
        if(0 <= cRelOpe && cRelOpe < nStrStr)
        {
            //ϐ֑B
            if(ead.kreg[1] != ASM_IMM_STR)
            {
                //ϐɑłȂB
                wcout <<L"G[ "<<ead.clum<< L"sځAϐ"<< m_vStrStr[cRelOpe] << L"ɑł͕̂񂾂łB\n";
                throw -1;
            }

            m_vStr[cRelOpe] = (wchar_t*)ead.reg[1];
            m_vStrBool[cRelOpe] = true;
            vStrBoolAll[ead.kreg[0]-posStrStr] = true;
            continue;
        }

        cRelOpe = ead.kreg[0] - posIntStr;
        if(0 <= cRelOpe && cRelOpe < nIntStr)
        {
            //lǂݍށB
			nr = 0;
			hr = 0;
			vdb[0]=1;
			vdb[1]=1;
			for(int j=0;j<ead.creg;j++)
			{
				switch (ead.kreg[j])
				{
				case ASM_IMM_DOUBLE:
				case ASM_IMM_INT:
					switch (ead.kreg[j])
					{
					case ASM_IMM_DOUBLE:
						vdb[nr] *= *(double*)ead.reg[j];
						break;
					case ASM_IMM_INT:
						vdb[nr] *= *(__int64*)ead.reg[j];
						break;
					}
					nr = 99;
					break;
				case tvE:
				case tve:
					if(nr == 1)
					{
						cout<<ead.clum<<"s : włB\n";
						throw -1;
					}
					nr++;
					break;
				case tvMinus:
					if(vdb[nr] < 0)
					{
						cout<<ead.clum<<"s : -2dɂĂ܂B\n";
						throw -1;
					}
					vdb[nr] *= -1;
					break;
				default:
					wcout <<L"G[ "<<ead.clum<< L"sځA^ϐ"<< m_vIntStr[cRelOpe] << L"ɑł̂͐lłB\n";
					throw -1;
					break;
				}

				if(nr == 99)
				{
					break;
				}
			}
			if(nr != 0 && nr == 99)
			{
				cout<<ead.clum<<"s : ԈltH[}bgłB\n";
				throw -1;
			}

            m_vInt[cRelOpe] = vdb[0]*pow(10,vdb[1]);
            m_vIntBool[cRelOpe] = true;
            vStrBoolAll[ead.kreg[0]-posStrStr] = true;
            continue;
        }


        cRelOpe = ead.kreg[0] - posDoubleStr;
        if(0 <= cRelOpe && cRelOpe < nDoubleStr)
        {
            //l̉\B
            //lǂݍށB
			nr = 0;
			hr = 0;
			vdb[0]=1;
			vdb[1]=1;
			for(int j=0;j<ead.creg;j++)
			{
				switch (ead.kreg[j])
				{
				case ASM_IMM_DOUBLE:
				case ASM_IMM_INT:
					switch (ead.kreg[j])
					{
					case ASM_IMM_DOUBLE:
						vdb[nr] *= *(double*)ead.reg[j];
						break;
					case ASM_IMM_INT:
						vdb[nr] *= *(__int64*)ead.reg[j];
						break;
					}
					nr = 99;
					break;
				case tvE:
				case tve:
					if(nr == 1)
					{
						cout<<ead.clum<<"s : włB\n";
						throw -1;
					}
					nr++;
					break;
				case tvMinus:
					if(vdb[nr] < 0)
					{
						cout<<ead.clum<<"s : -2dɂĂ܂B\n";
						throw -1;
					}
					vdb[nr] *= -1;
					break;
				default:
					wcout <<L"G[ "<<ead.clum<<L"sځA_^ϐ"<< m_vDoubleStr[cRelOpe] << L"ɑł̂͐lłB\n";
					throw -1;
					break;
				}

				if(nr == 99)
				{
					break;
				}
			}
			if(nr != 0 && nr == 99)
			{
				cout<<ead.clum<<"s : ԈltH[}bgłB\n";
				throw -1;
			}
            m_vDouble[cRelOpe] = vdb[0]*pow(10,vdb[1]);
            m_vDoubleBool[cRelOpe] = true;
            vStrBoolAll[ead.kreg[0]-posStrStr] = true;
            continue;
        }

        //ǂɂqbgȂB
        wcout <<L"G[ "<<ead.clum<< L"sځA`ĂȂʎq : "<< ead.str[0] << L"gpĂ܂B;̂Y͂܂񂩁H\n";
        throw -1;
    }

    //gpĂȂϐ\B
    for(int m1=0;m1<nStrAll;m1++)
    {
        if(vStrBoolAll[m1] == false)
        {
            wcout<<L"ϐ : " << vStrAll[m1+1] << L"͈xgpĂȂ悤łB\n";
        }
    }
}
vector<wstring> CTextValueLoader::GetStrVector()//lzB
{
    return m_vStr;
}
vector<int> CTextValueLoader::GetIntVector()//lzB
{
    return m_vInt;
}
vector<double> CTextValueLoader::GetDoubleVector()//lzB
{
    return m_vDouble;
}

vector<bool>   CTextValueLoader::GetStrBool()//l̎擾ɐǂB
{
    return m_vStrBool;
}
vector<bool>   CTextValueLoader::GetIntBool()
{
    return m_vIntBool;
}
vector<bool>   CTextValueLoader::GetDoubleBool()
{
    return m_vDoubleBool;
}

CTextValueLoader::~CTextValueLoader()
{

}
